"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
Object.defineProperty(exports, "__esModule", { value: true });
const debug_1 = require("debug");
const startServer_1 = require("./startServer");
const debug = debug_1.debug('cypress:vite-dev-server:vite');
function startDevServer(startDevServerArgs) {
    return __awaiter(this, void 0, void 0, function* () {
        const viteDevServer = yield startServer_1.start(startDevServerArgs);
        return new Promise((resolve) => __awaiter(this, void 0, void 0, function* () {
            const app = yield viteDevServer.listen();
            const port = app.config.server.port;
            debug('Component testing vite server started on port', port);
            resolve({ port, server: app.httpServer });
        }));
    });
}
exports.startDevServer = startDevServer;
