"use strict";
Object.defineProperty(exports, "__esModule", { value: true });
const path_1 = require("path");
const fs_1 = require("fs");
const mustache_1 = require("mustache");
const pluginName = 'cypress-transform-html';
const indexHtmlPath = path_1.resolve(__dirname, '../index-template.html');
const readIndexHtml = () => fs_1.readFileSync(indexHtmlPath).toString();
function handleIndex(indexHtml, projectRoot, supportFilePath, req, res) {
    const specPath = `/${req.headers.__cypress_spec_path}`;
    const supportPath = supportFilePath ? `/${path_1.relative(projectRoot, supportFilePath)}` : null;
    res.end(mustache_1.render(indexHtml, { supportPath, specPath }));
}
exports.makeHtmlPlugin = (projectRoot, supportFilePath) => {
    return {
        name: pluginName,
        enforce: 'pre',
        configureServer: (server) => {
            const indexHtml = readIndexHtml();
            server.middlewares.use('/index.html', (req, res) => handleIndex(indexHtml, projectRoot, supportFilePath, req, res));
        },
    };
};
