"use strict";
var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
const debug_1 = __importDefault(require("debug"));
const vite_1 = require("vite");
const path_1 = require("path");
const makeCypressPlugin_1 = require("./makeCypressPlugin");
const debug = debug_1.default('cypress:vite-dev-server:start');
// TODO: Pull in types for Options so we can infer these
const serverConfig = (projectRoot, supportFilePath, devServerEvents) => {
    return {
        root: path_1.resolve(__dirname, projectRoot),
        base: '/__cypress/src/',
        plugins: [makeCypressPlugin_1.makeCypressPlugin(projectRoot, supportFilePath, devServerEvents)],
        server: {
            port: 0,
        },
    };
};
const resolveServerConfig = ({ viteConfig, options }) => {
    const defaultServerConfig = serverConfig(options.config.projectRoot, options.config.supportFile, options.devServerEvents);
    const requiredOptions = {
        base: defaultServerConfig.base,
        root: defaultServerConfig.root,
    };
    const finalConfig = Object.assign(Object.assign(Object.assign({}, defaultServerConfig), viteConfig), requiredOptions);
    finalConfig.plugins = [...(viteConfig.plugins || []), defaultServerConfig.plugins[0]];
    finalConfig.server.port = defaultServerConfig.server.port;
    debug(`the resolved server config is ${JSON.stringify(finalConfig, null, 2)}`);
    return finalConfig;
};
function start(devServerOptions) {
    return __awaiter(this, void 0, void 0, function* () {
        if (!devServerOptions.viteConfig) {
            debug('User did not pass in any Vite dev server configuration');
            devServerOptions.viteConfig = {};
        }
        debug('starting vite dev server');
        const resolvedConfig = resolveServerConfig(devServerOptions);
        return vite_1.createServer(resolvedConfig);
    });
}
exports.start = start;
